C    --- main -- 
C
C        MMM = 99
C        CALL READ_STR(MMM,PATH,RNAMES,EXT,IERR)
C
C     
C        IMODE = 0
C        CALL TREE_INITIALIZATION(MDOC,IMODE,IFLAG_OCC,IERR)
C        IF(IERR.NE.0) GO TO 100
C --------
Cc         input:
Cc           IMODE = 0 - first tree initialization after READ_STR          
Cc                       (convert old style PSI to new and
Cc                        convert all angles to radian     )
Cc           else IMODE = 1
Cc         output:
Cc          if IFLAG_OCC = 1 - there are some atoms with OCC = 0.0
Cc                             (use ANGTOCR_STR with IMODE=1)
Cc                             (also if(IBACK.GT.0.AND.OCCUP(IBACK).LT.0.001)
Cc                                      use bond restrain
Cc          else IFLAG_OCC = 0
C --------
C
c
C        IMODE = 0
C        CALL CRTOANG_STR(IMODE,IERR)
C --------
cc        input:
cc         IMODE = 0 calc ATM_DIST(i),ATM_THETA(I),ATM_PSI(I) from coords
cc         IMODE = 1 calc only ATM_PSI(I) angles
cc        output:
Cc         IERR = 1 if some atoms have OCC = 0 and ATM_TYPE # 'R'. It means 
Cc                  not possible to calculate angles.
C --------
C        
C        ......
C        IMODE = 0
C        CALL ANGTOCR_STR(MDOC,IMODE,IERR)
C        IF(IERR.NE.0) RETURN
C --------
Cc       input:
Cc         IMODE = 1 new coords only for atoms with OCC = 0
Cc         else IMODE = 0
Cc            if atom has OCC = 0 and ATM_TYPE # 'R' after subroutine
Cc            atom will have ATM_TYPE = 'R'
Cc       output:
Cc         IERR = 1  wrong tree structure
Cc         IERR = 2  N-stack > limit
C --------
C        ......
C =====================================
C   PARTIAL_TREES
C
C  1. define N_TREE and IATM_FIRST_TREE(),IATM_LAST_TREE ()
C        
C  2. IMODE = 1
C     CALL TREE_INITIALIZATION(MDOC,IMODE,IFLAG_OCC,IER
C ---
C     IERR
C      10    N_TREE = 0 
C      11    IATM_FIRST_TREE() or IATM_LAST_TREE() = 0
C      12    IATM_FIRST_TREE(),IATM_LAST_TREE() not in the same tree
C      13    new FIRST or LAST not backbone atom
C      14    new FIRST or LAST has alt. atoms
C      15    some trees overlap
C       1    fatal error
C ---
C  3. . . . . . .
C
C  4. CALL BACK_TO_INITIAL_TREE(MDOC,IERR)
C
C --------------------------------------

      SUBROUTINE TREE_INITIALIZATION(MDOC,IMODE,IFLAG_OCC,IERR)
C --------------------------------------------------------
Cc         input:
Cc           IMODE = 0 - first tree initialization after READ_STR          
Cc                       (convert old style PSI to new and
Cc                        convert all angles to radian     )
Cc           else IMODE = 1
Cc         output:
Cc          if IFLAG_OCC = 1 - there are some atoms with OCC = 0.0
Cc          else IFLAG_OCC = 0
C --------------------------------------------------------
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
C -----------------------------------
      INTEGER   MDOC,IERR,IMODE
      CHARACTER LINE*80,ALT*1
C --------------------------------------------------------
      IERR = 0
      MD   = -ABS(MDOC)-1
      M    = 99
C --------
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      PI180 = PI/180.0
C --------
      IF(N_ATOM.LE.0) THEN
        LINE =' ERROR: in tree_initialization: N_atoms = 0'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        RETURN
      ENDIF
C --------
      IF(IMODE.EQ.1) THEN

        IF(N_TREE.LE.0.OR.N_TREE_INIT.LE.0) THEN
          IERR = 1
          RETURN
        ENDIF

        DO I=1,N_ATOM
          ID_TREE(I) =-ABS(ID_TREE(I))
        ENDDO 

        CALL PARTIAL_TREE_INITIALIZATION(MDOC,IERR)
        IF(IERR.NE.0) THEN
          RETURN
        ENDIF

      ELSE IF(IMODE.EQ.0) THEN

        DO I=1,N_ATOM
          ID_TREE(I) = 0
        ENDDO 
        N_TREE      = 0
        N_TREE_INIT = 0

        CALL ALTERNATIVE_TREE_CORRECTION(IMODE,IFLAG_ALT,IERR)      
        IF(IERR.NE.0) THEN
          RETURN
        ENDIF

      ENDIF
C --------
      IF(IMODE.NE.1) THEN      
        ITREE = 0
        DO I=1,N_ATOM
          ID_TREE(I) = 0
        ENDDO 
        CALL SET_CONNECTIVITIES(ITREE,IERR)
        IF(IERR.NE.0) RETURN
C --------
C       how many trees?
        DO I=1,N_ATOM
          IF(IATM_BACK(I).LE.0.AND.ATM_NDIST(I).GT.0) THEN
            IT = 0
            DO J=1,ATM_NDIST(I)
              JJ = ATM_CONN(J,I)
              IF(ATM_NDIST(JJ).GT.0) IT = 1
            ENDDO
            IF(IT.GT.0) THEN 
C             new tree
              N_TREE =  N_TREE + 1
              IF(N_TREE.GT.MAXTREE) THEN
                LINE =' ERROR: number of trees > limits'
                CALL MSGERR(MDOC,LINE)
                LINE ='        change MAXTREE in ref_com_str.fh'
                CALL MSGERR(MDOC,LINE)
                IERR = 1
                RETURN
              ENDIF
              IATM_FIRST_TREE(N_TREE) = I 
              XYZ_TREE(1,N_TREE)     = XYZ_CRD(1,I)
              XYZ_TREE(2,N_TREE)     = XYZ_CRD(2,I)
              XYZ_TREE(3,N_TREE)     = XYZ_CRD(3,I)
              ANGLES_TREE(1,N_TREE)  = 0.0
              ANGLES_TREE(2,N_TREE)  = 0.0
              ANGLES_TREE(3,N_TREE)  = 0.0
            ENDIF
          ENDIF 
        ENDDO
        IF(IMODE.EQ.0) N_TREE_INIT = N_TREE
      ENDIF 
C ----
      IF(N_TREE.LE.0) THEN
        LINE =' ERROR: in tree_initialization: N_trees = 0'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        RETURN
      ENDIF
C ----
C     set tree id and IATM_LAST_TREE      
      CALL CHECK_TREE_STR(MDOC,IFLAG_OCC,IERR)
      IF(IERR.NE.0) RETURN
C ---- 
      IF(IMODE.EQ.0) THEN
c     initial angles correction
        DO IDT=1,N_TREE
          DO I=1,N_ATOM
            IF(ID_TREE(I).EQ.IDT) THEN
              IF(ATM_THETA(I).LT.0.001) ATM_THETA(I) = 110.0
              ATM_THETA(I) = ATM_THETA(I)*PI180
              IFOR = IATM_FOR(I)
              IF(IFOR.LT.0) IFOR = ABS(IFOR)-1 
              IF(ATM_NDIST(I).GT.0.AND.IFOR.GT.0) THEN
                PHI0 = ATM_PSI(IFOR)*PI180                        
                DO J=1,ATM_NDIST(I)
                  JJ = ATM_CONN(J,I)
                  IF(JJ.NE.IFOR) THEN
                    ATM_PSI(JJ) = ATM_PSI(JJ)*PI180 + PHI0
                  ELSE
                    ATM_PSI(JJ) = PHI0
                    ID_PSI(I)   = ID_PSI(IFOR) 
                  ENDIF
                ENDDO
              ELSE
                ID_PSI(I) = 'C'             
              ENDIF
            ENDIF
          ENDDO
        ENDDO
      ENDIF
C ----
      DO I=1,N_TREE
        IATM_FIRST_TREE_C(I) = IATM_FIRST_TREE(I)
        IATM_LAST_TREE_C (I) = IATM_LAST_TREE (I)
      ENDDO
 
      IF(IFLAG_OCC.EQ.0) THEN 
        CALL NEW_TREE_ORIGIN(MDOC,IERR)
        IF(IERR.NE.0) RETURN
      ENDIF
C ----
C     set variable angles
c           
      N_PHI    = 0
      DO IDT=1,N_TREE
        DO I=1,N_ATOM
          IF(ID_TREE(I).EQ.IDT) THEN
            IB = IATM_BACK(I)
            IF(IB.LT.0) THEN
C             ID_PSI(I) = 'C'
              ID_PHI(I) = 0
            ELSE 
              IFOR = IATM_FOR(IB)
              IF(IFOR.LT.0) IFOR = ABS(IFOR)-1 
              IBB = IATM_BACK(IB)
              IF(IBB.LT.0) THEN
C               IF(I.EQ.IFOR) ID_PSI(I) = 'C'
                ID_PHI(I) = 0
              ELSE
                IBBB = IATM_BACK(IBB)
                IF(IBBB.LT.0) THEN
C                 IF(I.EQ.IFOR) ID_PSI(I) = 'C'
                  ID_PHI(I) = 0
                ELSE
                  IF((ID_PSI(IB)(1:1).EQ.'V'.OR.
     *                ID_PSI(IB)(1:1).EQ.'v').AND.I.EQ.IFOR) THEN
                    N_PHI = N_PHI + 1
                    IF(N_PHI.GT.MAXPHI) THEN
                      LINE =' ERROR: number of phi > limits'
                      CALL MSGERR(MDOC,LINE)
                      LINE ='        change MAXPHI in ref_com_str.fh'
                      CALL MSGERR(MDOC,LINE)
                      IERR = 1
                      RETURN
                    ENDIF
                    PHI_VAR(N_PHI)  = ATM_PSI(I)  
                    ID_PHI(I)      = N_PHI 
                    IP_PSI (N_PHI)  = I
                    PHI_TYPE(N_PHI) = ' '
                  ELSE
                    ID_PHI(I)   = 0
                  ENDIF
                ENDIF 
              ENDIF 
            ENDIF
          ENDIF
        ENDDO
      ENDDO
C ----
C     set constant angles
      IF(N_PHI.GT.0) THEN  
        DO IDT=1,N_TREE
          DO I=1,N_ATOM
            IF(ID_TREE(I).EQ.IDT) THEN
              IF(ATM_NDIST(I).GT.0) THEN
                IVAR = 0
                DO J=1,ATM_NDIST(I)
                  JJ = ATM_CONN(J,I)   
                  IF(ID_PHI(JJ).NE.0) IVAR = JJ
                ENDDO
                IF(IVAR.GT.0) THEN
                  ALT = ID_ALT(I)
                  DO J=1,ATM_NDIST(I)
                    JJ = ATM_CONN(J,I)
                    IF(ID_PHI(JJ).EQ.0)THEN
                      IF(ID_ALT(JJ).NE.ALT) THEN
                        N_PHI = N_PHI + 1
                        IF(N_PHI.GT.MAXPHI) THEN
                          LINE =' ERROR: number of phi > limits'
                          CALL MSGERR(MDOC,LINE)
                      LINE ='        change MAXPHI in ref_com_str.fh'
                          CALL MSGERR(MDOC,LINE)
                          IERR = 1
                          RETURN
                        ENDIF
                        PHI_VAR(N_PHI)  = ATM_PSI(JJ)  
                        ID_PHI(JJ)      = N_PHI 
                        IP_PSI (N_PHI)  = JJ
                        PHI_TYPE(N_PHI) = ' '
                      ELSE
                        ID_PHI(JJ) = ID_PHI(IVAR)
                      ENDIF                    
                    ENDIF
                  ENDDO  
                ENDIF
              ENDIF 
            ENDIF
          ENDDO
        ENDDO  
      ENDIF 
C ---
      WRITE(LINE,'(A,I5)') ' Number of trees:',N_TREE
      CALL MSGDOC(MDOC,LINE)

      CALL SET_DUMMY_ATOMS

      IF(N_PHI.LE.0) THEN
        LINE =' WARNING: in tree_initialization: N_variable angels = 0'
        CALL MSGERR(MDOC,LINE)
      ENDIF
C ---       
C     only for libcheck
      ATM_ISTART  = 1
      ATM_IFINISH = 1
      ATM_NDUMMY  = 0
C
c      do i=1,n_tree
c        write(*,*) '-',i,IATM_FIRST_TREE_c(i), XYZ_TREE(1,i)
c     *  , XYZ_TREE(2,i), XYZ_TREE(3,i)
c        j = IATM_FIRST_TREE_c(i)   
c        write(*,*) '        ',j,XYZ_crd(1,j)
c     *  , XYZ_crd(2,j), XYZ_crd(3,j)   
c        j = IATM_LAST_TREE_c(i)
c        write(*,*)   '        ',j,XYZ_CRD(1,j),XYZ_CRD(2,j),XYZ_CRD(3,j)
c      enddo
c
c        do i=1,n_atom
c          write(*,*) i,iatm_back(i),iatm_for(I)
c       enddo
c
c       do i=1,n_atom
c         write(*,*) i,atm_dist(i),atm_theta(I),ATM_PSI(I)
c         write(*,*) '    ',ID_TREE(I),ID_PSI(I),ID_PHI(I)
c       enddo
c
c        DO I=1,N_PHI
c          write(*,*)'var:',i,IP_PSI(I),PHI_VAR(I)
c        ENDDO
c
C      
C --------
      RETURN
      END

      SUBROUTINE SET_DUMMY_ATOMS
C -----------------------------------
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
C ---
      REAL V(3)
C -----------------------------------      
      IF(N_TREE.LE.0) RETURN

      DO IDT=1,N_TREE
c        I  = IATM_FIRST_TREE_C(IDT)
c        II = IATM_FOR(I)
c        IF(II.LT.0) II = ABS(II)-1
c
c        IF(ATM_NDIST(I).LE.1) THEN
c          DUMMY_TREE_2(1,IDT) = XYZ_CRD(1,II)-XYZ_CRD(1,I)
c          DUMMY_TREE_2(2,IDT) = XYZ_CRD(2,II)-XYZ_CRD(2,I)
c          DUMMY_TREE_2(3,IDT) = XYZ_CRD(3,II)-XYZ_CRD(3,I)
c          III = IATM_FOR(II)
c          IF(III.LT.0) III = ABS(III)-1
c          DUMMY_TREE_1(1,IDT) = XYZ_CRD(1,III)-XYZ_CRD(1,II)
c          DUMMY_TREE_1(2,IDT) = XYZ_CRD(2,III)-XYZ_CRD(2,II)
c          DUMMY_TREE_1(3,IDT) = XYZ_CRD(3,III)-XYZ_CRD(3,II)
c        ELSE
C
C          V(1) = 0.0
C          V(2) = 0.0
C          V(3) = 0.0
C          N    = 0
C          DO J=1,ATM_NDIST(I)
C            JJ   = ATM_CONN(J,I)
C            N    = N + 1
C            V(1) = V(1) + XYZ_CRD(1,J) 
C            V(2) = V(2) + XYZ_CRD(2,J) 
C            V(3) = V(3) + XYZ_CRD(3,J) 
C          ENDDO
C          DUMMY_TREE_1(1,IDT) = V(1)/FLOAT(N)
C          DUMMY_TREE_1(2,IDT) = V(2)/FLOAT(N)
C          DUMMY_TREE_1(3,IDT) = V(3)/FLOAT(N)
C          DUMMY_TREE_2(1,IDT) = 0
C          DUMMY_TREE_2(2,IDT) = 0
C          DUMMY_TREE_2(3,IDT) = 0
C
          DUMMY_TREE_1(1,IDT) = 1.0        
          DUMMY_TREE_1(2,IDT) = 0.0        
          DUMMY_TREE_1(3,IDT) = 0.0        
          DUMMY_TREE_2(1,IDT) = 0.0        
          DUMMY_TREE_2(2,IDT) =-1.0        
          DUMMY_TREE_2(3,IDT) = 0.0        
c        ENDIF
c          write(*,*) 'd1:',DUMMY_TREE_1(1,IDT)
c     *                   ,DUMMY_TREE_1(2,IDT) DUMMY_TREE_1(3,IDT)
c          write(*,*) 'd2:',DUMMY_TREE_2(1,IDT)
c     *                   ,DUMMY_TREE_2(2,IDT) DUMMY_TREE_2(3,IDT)
      ENDDO
C ---
      RETURN
      END

      SUBROUTINE SET_VARIABLE_ANGLES
C -----------------------------------
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
C -----------------------------------      
      IF(N_PHI.GT.0) THEN
        DO I=1,N_PHI
          J  = IP_PSI(I)
          IF(ID_PHI(J).EQ.I) THEN
            PHI_VAR(I) = ATM_PSI(J)
          ENDIF
        ENDDO
      ENDIF
      RETURN
      END 

      SUBROUTINE GET_VARIABLE_ANGLES
C -----------------------------------
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
C -----------------------------------      
      IF(N_PHI.GT.0.AND.N_TREE.GT.0) THEN

C       change constant angles
        DO IDT=1,N_TREE
          DO I=1,N_ATOM
            IF(ID_TREE(I).EQ.IDT) THEN
              IPHI = ID_PHI(I)
              IF(IPHI.GT.0) THEN
                J = IP_PSI(IPHI)
                IF(I.EQ.J) THEN
C                  ATM_PSI(I) = PHI_VAR(IPHI)
                ELSE                    
                  ATM_PSI(I) =  ATM_PSI(I) + (PHI_VAR(IPHI)-ATM_PSI(J))
                ENDIF
              ENDIF
            ENDIF
          ENDDO
        ENDDO
C       change variable angles
        DO IDT=1,N_TREE
          DO I=1,N_ATOM
            IF(ID_TREE(I).EQ.IDT) THEN
              IPHI = ID_PHI(I)
              IF(IPHI.GT.0) THEN
                J = IP_PSI(IPHI)
                IF(I.EQ.J) THEN
                  ATM_PSI(I) = PHI_VAR(IPHI)
                ELSE                    
c                 ATM_PSI(I) =  ATM_PSI(I) + (PHI_VAR(IPHI)-ATM_PSI(I))
                ENDIF
              ENDIF
            ENDIF
          ENDDO
        ENDDO
C ----
      ENDIF
      RETURN
      END 

      SUBROUTINE SET_CONNECTIVITIES(ITREE,IERR)      
C --------------------------------------------------------
C      set connectiviies
C --------------------------------------------------------
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
      CHARACTER LINE*80
C -----------------------------------
      IERR = 0
      DO I=1,N_ATOM
        IF(ID_TREE(I).EQ.ITREE.OR.ITREE.EQ.0) THEN

          ATM_NDIST(I) = 0

          DO JA=1,N_ATOM
            IF(ID_TREE(JA).EQ.ITREE.OR.ITREE.EQ.0) THEN
              IF(IATM_BACK(JA).EQ.I.AND.I.NE.JA) THEN
                IF(ATM_NDIST(I).LT.MAXBRN) THEN
                  ATM_NDIST(I) = ATM_NDIST(I) + 1
                  ATM_CONN(ATM_NDIST(I),I) = JA
                ELSE
                  LINE =
     *' ERROR: in SET_CONNECTIVITIES: number of connections > limits'
                  CALL MSGERR(MDOC,LINE)
                  LINE ='        change MAXBRN in ref_com_str.fh'
                  CALL MSGERR(MDOC,LINE)
                  IERR = 1
                  RETURN
                ENDIF
              ENDIF
            ENDIF
          ENDDO
          IF(ATM_NDIST(I).GT.1) THEN
            DO JA=1,ATM_NDIST(I)
              IFOR = IATM_FOR(I)
              IF(IFOR.LT.0) IFOR = ABS(IFOR)-1 
              IF(ATM_CONN(JA,I).EQ.IFOR) THEN
                IT = ATM_CONN(JA,I) 
                ATM_CONN(JA,I) = ATM_CONN(ATM_NDIST(I),I) 
                ATM_CONN(ATM_NDIST(I),I) = IT
              ENDIF
            ENDDO
          ENDIF
        ENDIF
      ENDDO
C ---      
      RETURN
      END 

      SUBROUTINE CRTOANG_STR(IMODE,IERR)
C --------------------------------------------------------
c     input:
c       IMODE = 0 calc ATM_DIST(i),ATM_THETA(I),ATM_PSI(I) from coords
c       IMODE = 1 calc only ATM_PSI(I) angles
c     output:
C       IERR = 1 if some atoms have OCC = 0 and ATM_TYPE # 'R'. It means 
C                not possible to calculate angles.
C --------------------------------------------------------
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
C ----
      REAL      V1(3),V2(3),V3(3)
      INTEGER   I,I1,I2,I3,IDT,IMODE,IERR
      REAL      PI,TWOPI,PI180,ALPHA,TANGLE,XX,YY,ZZ  
C------------------------------------
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      PI180 = PI/180.0
C -----------------------------------
      IERR = 0
      DO I=1,N_ATOM

        IDT = ID_TREE(I)
        IF(IDT.GT.0) THEN 
          IF(OCCUP(I).LT.0.001.AND.ATM_TYPE(I).NE.'R') THEN
            IERR = 1
            GO TO 100
          ENDIF
          I1 = IATM_BACK(I)
          IF(I1.LE.0) THEN
            CALL CALC_THETA_ANGLES(DUMMY_TREE_2(1,IDT)
     *                            ,DUMMY_TREE_1(1,IDT),THETA)
            CALL NB_VMOD(DUMMY_TREE_1(1,IDT),D1)
            ATM_DIST(I)  = D1
            ATM_THETA(I) = THETA
            ATM_PSI  (I) = 0.0
            GO TO 100
          ENDIF

          IF(OCCUP(I1).LT.0.001.AND.ATM_TYPE(I1).NE.'R') THEN
            IERR = 1
            GO TO 100
          ENDIF
          V3(1) = XYZ_CRD(1,I)-XYZ_CRD(1,I1)
          V3(2) = XYZ_CRD(2,I)-XYZ_CRD(2,I1)
          V3(3) = XYZ_CRD(3,I)-XYZ_CRD(3,I1)

          I2  = IATM_BACK(I1)
          II2 = I2

 200      CONTINUE

          IF(II2.GT.0) THEN
            I3 = IATM_BACK(II2)
          ELSE
            I3 = 0
          ENDIF

          IF(II2.LE.0) THEN
            V2(1) = DUMMY_TREE_1(1,IDT)
            V2(2) = DUMMY_TREE_1(2,IDT) 
            V2(3) = DUMMY_TREE_1(3,IDT) 
            V1(1) = DUMMY_TREE_2(1,IDT) 
            V1(2) = DUMMY_TREE_2(2,IDT)
            V1(3) = DUMMY_TREE_2(3,IDT) 
          ELSE
            IF(OCCUP(II2).LT.0.001.AND.ATM_TYPE(II2).NE.'R') THEN
              IERR = 1
              GO TO 100
            ENDIF
            V2(1) = XYZ_CRD(1,I1)-XYZ_CRD(1,II2)
            V2(2) = XYZ_CRD(2,I1)-XYZ_CRD(2,II2)
            V2(3) = XYZ_CRD(3,I1)-XYZ_CRD(3,II2)
            IF(I3.LE.0) THEN
              V1(1) = DUMMY_TREE_1(1,IDT)
              V1(2) = DUMMY_TREE_1(2,IDT)
              V1(3) = DUMMY_TREE_1(3,IDT)
            ELSE
              IF(OCCUP(I3).LT.0.001.AND.ATM_TYPE(I3).NE.'R') THEN
                IERR = 1
                GO TO 100
              ENDIF
              V1(1) = XYZ_CRD(1,II2)-XYZ_CRD(1,I3)
              V1(2) = XYZ_CRD(2,II2)-XYZ_CRD(2,I3)
              V1(3) = XYZ_CRD(3,II2)-XYZ_CRD(3,I3)
            ENDIF
          ENDIF
          CALL CALC_THETA_ANGLES(V1,V2,ANG1)
          D = PI - 0.0875
C         175 grad
          IF(ANG1.GT.D.AND.II2.GT.0) THEN
            IB  = IATM_BACK(II2)
            II2 = IB
            GO TO 200
          ENDIF

          CALL CALC_THETA_TORS_ANGLES(V1,V2,V3,TANGLE,ALPHA)
C ---------------------------------------------------
C                           torsion ALPHA, TANGLE in rad.  
C         IBBB -- V1 --> IBB  --- V2 ---> IB -- V3 --> I
C ---------------------------------------------------
          IF(IMODE.EQ.0) THEN
            CALL NB_VMOD(V3,D1)
            ATM_DIST(I) = D1
          ENDIF

          IF(IMODE.EQ.0.OR.I2.LT.0) THEN
            ATM_THETA(I) = TANGLE
          ENDIF

          ATM_PSI(I) = ALPHA

 100      CONTINUE
       
        ENDIF
      ENDDO

C     ATM_PSI() --> PHI_VAR() 
      CALL SET_VARIABLE_ANGLES
 
c       do i=1,20
c         ttt1 = ATM_THETA(I)/pi180
c         ttt2 = ATM_PSI(I)/pi180
c         write(*,*) i,ATM_DIST(i),ttt1,ttt2
c       enddo


      DO ITREE=1,N_TREE 
        IFIRST = IATM_FIRST_TREE_C(ITREE)
        XYZ_TREE(1,ITREE)     = XYZ_CRD(1,IFIRST)
        XYZ_TREE(2,ITREE)     = XYZ_CRD(2,IFIRST)
        XYZ_TREE(3,ITREE)     = XYZ_CRD(3,IFIRST)
        ANGLES_TREE(1,ITREE)  = 0.0
        ANGLES_TREE(2,ITREE)  = 0.0
        ANGLES_TREE(3,ITREE)  = 0.0
      ENDDO
C ----
      RETURN
      END

      SUBROUTINE CALC_THETA_TORS_ANGLES(V1,V2,V3,THETA,ANGLE)
C ---------------------------------------------------
C                       torsion ANGLE, THETA in rad.  
C     IBBB -- V1 --> IBB  --- V2 ---> IB -- V3 --> I
C ---------------------------------------------------
      REAL V1(3),V2(3),V3(3),THETA,ANGLE,PI,TWOPI,ANGOBS 
      REAL*8 DANGLE,A1,A2,A3,B1,B2,B3,C1,C2,C3,AMOD,T,COST,DANGOBS 
      REAL*8 DN1X,DN1Y,DN1Z,DN2X,DN2Y,DN2Z,E1,E2,E3,COSG,SING,ABC,SS       
C -----------------------------------------------       
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
C     DBLE(BET2),DEXP(D),SNGL(DLMM(M1,M2),PI=3.14159265359
C ------------
      CALL CALC_THETA_ANGLES(V2,V3,THETA)
      A1   = V1(1)
      B1   = V1(2)
      C1   = V1(3)
      A2   = V2(1)
      B2   = V2(2)
      C2   = V2(3)
      A3   = V3(1)
      B3   = V3(2)
      C3   = V3(3)
      DN1X = B1*C2-B2*C1
      DN1Y = A1*C2-A2*C1
      DN1Z = A1*B2-A2*B1
      DN2X = B2*C3-B3*C2
      DN2Y = A2*C3-A3*C2
      DN2Z = A2*B3-A3*B2
      E1   = DN1X*DN2X+DN1Y*DN2Y+DN1Z*DN2Z
      E2   = DSQRT(DN1X*DN1X+DN1Y*DN1Y+DN1Z*DN1Z)
      E3   = DSQRT(DN2X*DN2X+DN2Y*DN2Y+DN2Z*DN2Z)
      IF(E2.LT.1.D-10.OR.E3.LT.1.D-10) THEN
        IF(E1.GE.0.) COSG = 1.
        IF(E1.LT.0.) COSG =-1.
      ELSE
        T    = E2*E3
        IF(T.LT.1.0D-10) T = 1.0
        COSG = E1/T
      ENDIF
      IF(COSG.GT. 1.0) COSG = 1.0
      IF(COSG.LT.-1.0) COSG =-1.0
C ------------------
      ABC    = A1*DN2X-A2*(B1*C3-B3*C1)+A3*DN1X
      SS     = 1.0 - COSG*COSG
      SS     = DABS(SS)
      SING   = DSQRT(SS)
      IF(ABC.LT.0) SING = -SING
      DANGLE = DATAN2(SING,COSG)
      ANGLE  = DANGLE 
      IF(ANGLE.GE. TWOPI) ANGLE = ANGLE - TWOPI
      IF(ANGLE.LE.-TWOPI) ANGLE = ANGLE + TWOPI
      IF(ANGLE.GT. PI) ANGLE = ANGLE - TWOPI
      IF(ANGLE.LE.-PI) ANGLE = ANGLE + TWOPI
C ------------------
      RETURN  
      END

      SUBROUTINE CALC_THETA_ANGLES(V2,V3,THETA)
C ---------------------------------------------------
C                                       THETA in rad.  
C       IBB --> V2 ---> IB -- V3 --> I
C ---------------------------------------------------
      REAL   V2(3),V3(3),THETA,PI,TWOPI,ANGOBS 
      REAL*8 DANGLE,A2,A3,B2,B3,C2,C3,AMOD,T,COST,DANGOBS        
C -----------------------------------------------       
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
C     DBLE(BET2),DEXP(D),SNGL(DLMM(M1,M2),PI=3.14159265359
C ------------
      A2 = V2(1)
      B2 = V2(2)
      C2 = V2(3)
      A3 = V3(1)
      B3 = V3(2)
      C3 = V3(3)
      T  = DSQRT(A2*A2+B2*B2+C2*C2)*DSQRT(A3*A3+B3*B3+C3*C3)
      AMOD = DABS(T)
      T    = AMOD
      IF(T.LT.1.0D-10) T = 1.0
      COST   = (A3*A2+B3*B2+C3*C2)/T
      IF(COST.GT. 1.0) COST = 1.0
      IF(COST.LT.-1.0) COST =-1.0
      DANGOBS  = DACOS(COST)
      ANGOBS   = DANGOBS
      ANGOBS   = PI-ANGOBS
      IF(ANGOBS.GT. PI) ANGOBS = ANGOBS - TWOPI
      IF(ANGOBS.LT.-PI) ANGOBS = ANGOBS + TWOPI

      THETA = ANGOBS

C ------------------
      RETURN  
      END

      SUBROUTINE POLTOCRD_STR(INEXT,I,N,A,XYZ,XYZ_NEXT,X
     *                    ,LENGTH,THETA,PHI)
C ---------------------
      REAL      LENGTH(*),X(3,*),THETA(*),PHI(*)
      REAL*8    A(3,3),XYZ(3),XYZ_NEXT(3) 
      INTEGER   I,N,INEXT         
      REAL      PHII,THETAI,PI,TWOPI,PI180
      REAL *8   DTHETA,DPHI,DL,DX(3),DY(3),DDX   
C ---------------------------------------
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      PI180 = PI/180.0
C -----------------------------------
c      PHII   = PHI(INEXT)*PI180
c      THETAI = THETA(INEXT)*PI180
      PHII   = PHI(INEXT)
      THETAI = THETA(INEXT)

      DPHI   = PHII
      DTHETA = THETAI
      DL     = LENGTH(INEXT)

      DX(1)  =-DCOS(DTHETA)*DL
      DDX    = DSIN(DTHETA)*DL
      DX(2)  = DCOS(DPHI)*DDX
      DX(3)  = DSIN(DPHI)*DDX

C     CALL NB_MVMULT(A,DX,DY)
      CALL NBD_MVMULT(A,DX,DY)
      
      XYZ_NEXT(1) = XYZ(1) + DY(1)
      XYZ_NEXT(2) = XYZ(2) + DY(2)
      XYZ_NEXT(3) = XYZ(3) + DY(3)

      X(1,INEXT) = XYZ_NEXT(1)
      X(2,INEXT) = XYZ_NEXT(2)
      X(3,INEXT) = XYZ_NEXT(3)

      RETURN
      END

      SUBROUTINE ANGTOCR_STR(MDOC,IMODE,IERR)
C -----------------------------------------------
Cc    input:
Cc      IMODE = 1 new coors only for atoms with OCC = 0
Cc      else IMODE = 0
Cc            if atom has OCC = 0 and ATM_TYPE # 'R' after subroutine
Cc            atom will have ATM_TYPE = 'R'
Cc    output:
Cc      IERR = 1  wrong tree structure
Cc      IERR = 2  N-stack > limit
C -----------------------------------------------
      INTEGER*4 MDOC,IERR
C ---
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
C ---
      PARAMETER ( NSTLIM = 1000 )
      INTEGER   NSTCK,ISTACK(NSTLIM),ICSTACK(NSTLIM)
      REAL*8    ASTACK(3,3,NSTLIM),XYZ_STACK(3,NSTLIM)
C --------------------------------------
      REAL*8    A(3,3),XYZ(3),XYZ_NEXT(3)

      REAL*8    DALPHA1,DALPHA2,DALPHA3,DROT(3,3)
      REAL*8    DDUMMY1(3),DDUMMY2(3),DV1(3),DV2(3)
      REAL      DUMMY1(3),DUMMY2(3),ROT(3,3),V1(3),V2(3),TR(3)
      INTEGER   IC
      CHARACTER LINE*80
C ---------------------------------------
C                                  RAD
C      SUBROUTINE  NB_EUL2MATR(ALPHA1,ALPHA2,ALPHA3,ROT_TEMP)

C ----
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      PI180 = PI/180.0
      IERR  = 0
C ----

C     PHI_VAR() --> ATM_PSI() 
      CALL GET_VARIABLE_ANGLES

c       do i=1,n_atom
c         write(*,*) '<',i,ATM_DIST(i),ATM_THETA(I),ATM_PSI(I)
c       enddo

      IF(N_TREE.LE.0) RETURN

      DO ITREE=1,N_TREE

      ALPHA1 = ANGLES_TREE(1,ITREE)
      ALPHA2 = ANGLES_TREE(2,ITREE)
      ALPHA3 = ANGLES_TREE(3,ITREE)  

 
      ISTART = IATM_FIRST_TREE_C(ITREE)

      DUMMY1(1) = DUMMY_TREE_1(1,ITREE)        
      DUMMY1(2) = DUMMY_TREE_1(2,ITREE)          
      DUMMY1(3) = DUMMY_TREE_1(3,ITREE)          
      DUMMY2(1) = DUMMY_TREE_2(1,ITREE)         
      DUMMY2(2) = DUMMY_TREE_2(2,ITREE)         
      DUMMY2(3) = DUMMY_TREE_2(3,ITREE)         

      DALPHA1 = ALPHA1  
      DALPHA2 = ALPHA2  
      DALPHA3 = ALPHA3  
      DDUMMY1(1) = DUMMY1(1)
      DDUMMY1(2) = DUMMY1(2)
      DDUMMY1(3) = DUMMY1(3)
      DDUMMY2(1) = DUMMY2(1)
      DDUMMY2(2) = DUMMY2(2)
      DDUMMY2(3) = DUMMY2(3)
C      CALL NB_EUL2MATR(ALPHA1,ALPHA2,ALPHA3,ROT)
      CALL NBD_EUL2MATR(DALPHA1,DALPHA2,DALPHA3,DROT)

C      CALL NB_MVMULT(ROT,DUMMY1,DV1)
C      CALL NB_MVMULT(ROT,DUMMY2,DV2)

      CALL NBD_MVMULT(DROT,DDUMMY1,DV1)
      CALL NBD_MVMULT(DROT,DDUMMY2,DV2)

      V1(1) = DV1(1)
      V1(2) = DV1(2)
      V1(3) = DV1(3)
      V2(1) = DV2(1)
      V2(2) = DV2(2)
      V2(3) = DV2(3)
        
      CALL CALC_THETA_TORS_ANGLES(DUMMY2,DUMMY1,V2,TH2,PHI2)
      CALL CALC_THETA_TORS_ANGLES(DUMMY1,V2,V1,TH1,PHI1)

C     1)    --> V2   D=SQRT(2.0)  TH=TH2  PHI=PHI2
C     2) V2 --> V1   D=1.0        TH=TH1  PHI=PHI1
C
      CALL INIT_AMAT(A,TH1,TH2,PHI1,PHI2)
C
      I        = ISTART
      IC       = 1
      NSTCK    = 0

      XYZ_CRD(1,I) = XYZ_TREE(1,ITREE)
      XYZ_CRD(2,I) = XYZ_TREE(2,ITREE)
      XYZ_CRD(3,I) = XYZ_TREE(3,ITREE)

      XYZ(1)       = XYZ_CRD(1,I)
      XYZ(2)       = XYZ_CRD(2,I)
      XYZ(3)       = XYZ_CRD(3,I)

  400 CONTINUE

      N = ATM_NDIST(I)

      IF(N.LE.0.AND.NSTCK.LE.0) GO TO 500

        IF(N.EQ.0) THEN

          IF(NSTCK.LE.0) THEN
            GO TO 2000
          ENDIF
 
          I     = ISTACK (NSTCK)
          IC    = ICSTACK(NSTCK)
C         CALL  NB_MCOPY(ASTACK(1,1,NSTCK),A)
          CALL  NBD_MCOPY(ASTACK(1,1,NSTCK),A)
          XYZ(1) = XYZ_STACK(1,NSTCK)
          XYZ(2) = XYZ_STACK(2,NSTCK)
          XYZ(3) = XYZ_STACK(3,NSTCK)
          NSTCK = NSTCK-1
          IF(I.LE.0.OR.IC.LE.0) THEN
            GO TO 2000
          ENDIF

        ELSE IF(N.EQ.1) THEN

          INEXT = ATM_CONN(1,I)
          IF(IMODE.EQ.0.OR.
     *       (OCCUP(INEXT).LT.0.001.AND.ATM_TYPE(INEXT).NE.'R')) THEN
            CALL POLTOCRD_STR(INEXT,I,N,A,XYZ,XYZ_NEXT,XYZ_CRD
     *          ,ATM_DIST,ATM_THETA,ATM_PSI)
            IF(OCCUP(INEXT).LT.0.001.AND.ATM_TYPE(INEXT).NE.'R') THEN
              ATM_TYPE(INEXT) = 'R'
            ENDIF
          ELSE
            XYZ_NEXT(1) = XYZ_CRD(1,INEXT) 
            XYZ_NEXT(2) = XYZ_CRD(2,INEXT) 
            XYZ_NEXT(3) = XYZ_CRD(3,INEXT) 
          ENDIF
c          CALL POLTOCRD_STR_NEW(INEXT,I,N,A,XYZ_CRD,V1,V2
c     *        ,IATM_BACK,ATM_DIST,ATM_THETA,ATM_PSI,ATM_CONN,MAXBRN)


          CALL CHANGE_AMAT(INEXT,I,N,A,ATM_THETA,ATM_PSI)
          XYZ(1) = XYZ_NEXT(1)
          XYZ(2) = XYZ_NEXT(2)
          XYZ(3) = XYZ_NEXT(3)

          IC    = 1
          I     = INEXT

        ELSE IF(N.GT.1) THEN

          INEXT = ATM_CONN(IC,I)

          IF(IMODE.EQ.0.OR.
     *       (OCCUP(INEXT).LT.0.001.AND.ATM_TYPE(INEXT).NE.'R')) THEN
            CALL POLTOCRD_STR(INEXT,I,N,A,XYZ,XYZ_NEXT,XYZ_CRD
     *          ,ATM_DIST,ATM_THETA,ATM_PSI)
            IF(OCCUP(INEXT).LT.0.001.AND.ATM_TYPE(INEXT).NE.'R') THEN
              ATM_TYPE(INEXT) = 'R'
            ENDIF
          ELSE
            XYZ_NEXT(1) = XYZ_CRD(1,INEXT) 
            XYZ_NEXT(2) = XYZ_CRD(2,INEXT) 
            XYZ_NEXT(3) = XYZ_CRD(3,INEXT) 
          ENDIF
c          CALL POLTOCRD_STR_NEW(INEXT,I,N,A,XYZ_CRD,V1,V2
c     *        ,IATM_BACK,ATM_DIST,ATM_THETA,ATM_PSI,ATM_CONN,MAXBRN)

          IF(IC.LT.N) THEN
            IC    = IC + 1
            NSTCK = NSTCK + 1
            IF(NSTCK.GT.NSTLIM) THEN
              WRITE(LINE,
     *        '('' ERROR: in ANGTOCR_STR: N-stack > '',I6)')
     *        NSTLIM
              CALL MSGERR(MDOC,LINE)
              IERR=2
              GO TO 2000
            ENDIF

            ISTACK(NSTCK)  = I
            ICSTACK(NSTCK) = IC
C           CALL  NB_MCOPY(A,ASTACK(1,1,NSTCK))
            CALL  NBD_MCOPY(A,ASTACK(1,1,NSTCK))
            XYZ_STACK(1,NSTCK) = XYZ(1) 
            XYZ_STACK(2,NSTCK) = XYZ(2) 
            XYZ_STACK(3,NSTCK) = XYZ(3) 

          ENDIF
   
          CALL CHANGE_AMAT(INEXT,I,N,A,ATM_THETA,ATM_PSI)
          XYZ(1) = XYZ_NEXT(1)
          XYZ(2) = XYZ_NEXT(2)
          XYZ(3) = XYZ_NEXT(3)
          I  = INEXT
          IC = 1

        ELSE

          GO TO 2000

        ENDIF
      GO TO 400
C -----------------
  500 CONTINUE

c       do i=1,n_atom
c         write(*,*) '>',i,atm_dist(i),atm_theta(I),ATM_PSI(I)
c         write(*,*) '     ',ID_TREE(I),ID_PSI(I),ID_PHI(I)
c       enddo
c      
c      I = IATM_FIRST_TREE_C(ITREE)
c      write(*,*) '==',ITREE,i,XYZ_CRD(1,I),XYZ_CRD(2,I),XYZ_CRD(3,I)
c      j = IATM_LAST_TREE(itree)
c      write(*,*) '      ',j,XYZ_CRD(1,j),XYZ_CRD(2,j),XYZ_CRD(3,j)

      ENDDO

      RETURN
C ------------------
 2000 CONTINUE
      LINE = ' WARNING: ANGTOCR : wrong tree structure'
      CALL MSGERR(MDOC,LINE)
      IERR = 1
      RETURN    
      END

      SUBROUTINE CHANGE_AMAT(INEXT,I,N,A,THETA,PHI)
C ---------------------
      REAL*8    A(3,3)
      REAL      THETA(*),PHI(*)
      INTEGER   INEXT,I,N
      REAL*8    Y(3,3),Z(3,3),COST,SINT,SINF,COSF,DT,DF
      REAL      PI,TWOPI,PI180,PHI0,PHII,THETAI,T,F
C ---------------------------------------
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      PI180 = PI/180.0
C -----------------------------------
c      PHII   = PHI(INEXT)*PI180
c      THETAI = THETA(INEXT)*PI180
      PHII   = PHI(INEXT)
      THETAI = THETA(INEXT)
C ---
      T = PI - THETAI
      F = PHII  

      DT = T
      DF = F
      COST   = DCOS(DT)
      SINT   = DSIN(DT)
      COSF   = DCOS(DF)
      SINF   = DSIN(DF)
C ---
      Y(1,1) = COST
      Y(1,2) =-SINT
      Y(1,3) = 0.0
      Y(2,1) = SINT*COSF
      Y(2,2) = COST*COSF
      Y(2,3) =-SINF
      Y(3,1) = SINT*SINF
      Y(3,2) = COST*SINF
      Y(3,3) = COSF


C      CALL NB_MATMLT(A,Y,Z)
C      CALL NB_MCOPY(Z,A)
      CALL NBD_MATMLT(A,Y,Z)
      CALL NBD_MCOPY(Z,A)
C ---
      RETURN
      END

      SUBROUTINE INIT_AMAT(A,TH1,TH2,PHI1,PHI2)
C ---------------------
      REAL*8    A(3,3)
      REAL      TH1,TH2,PHI1,PHI2
      REAL*8    Y(3,3),Z(3,3),COST,SINT,SINF,COSF,DT,DF
      REAL      PI,T,F
C ---------------------------------------
      PI    = 4.0*ATAN(1.0)
C -----------------------------------
C     1)    --> V2   D=SQRT(2.0)  TH=TH2  PHI=PHI2
C     2) V2 --> V1   D=1.0        TH=TH1  PHI=PHI1
C -----------------------
      DO I=1,3
      DO J=1,3
        A(I,J) = 0.0
      ENDDO
      ENDDO
      A(1,1) = 1.0
      A(2,2) = 1.0
      A(3,3) = 1.0
C ---
      T = PI - TH2
      F = PHI2       

      DT = T
      DF = F

      COST   = DCOS(DT)
      SINT   = DSIN(DT)
      COSF   = DCOS(DF)
      SINF   = DSIN(DF)
C ---
      Y(1,1) = COST
      Y(1,2) =-SINT
      Y(1,3) = 0.0
      Y(2,1) = SINT*COSF
      Y(2,2) = COST*COSF
      Y(2,3) =-SINF
      Y(3,1) = SINT*SINF
      Y(3,2) = COST*SINF
      Y(3,3) = COSF

      CALL NBD_MATMLT(A,Y,Z)
      CALL NBD_MCOPY(Z,A)

      T = PI - TH1
      F = PHI1       

      DT = T
      DF = F

      COST   = DCOS(DT)
      SINT   = DSIN(DT)
      COSF   = DCOS(DF)
      SINF   = DSIN(DF)
C ---
      Y(1,1) = COST
      Y(1,2) =-SINT
      Y(1,3) = 0.0
      Y(2,1) = SINT*COSF
      Y(2,2) = COST*COSF
      Y(2,3) =-SINF
      Y(3,1) = SINT*SINF
      Y(3,2) = COST*SINF
      Y(3,3) = COSF

C      CALL NB_MATMLT(A,Y,Z)
C      CALL NB_MCOPY(Z,A)
      CALL NBD_MATMLT(A,Y,Z)
      CALL NBD_MCOPY(Z,A)
C ---
      RETURN
      END

      SUBROUTINE NBD_MVMULT(AM,X,Y)
      REAL*8 X(3),Y(3),AM(3,3)
C      REAL   XX(3),YY(3)
C -P- NB_MVMULT -  Y =[AM] X
C                             !1!   ! 11 12 13 !    !1!
C           Y =[AM] X       Y !2! = ! 21 22 23 !  X !2!
C                             !3!   ! 31 32 33 !    !3!
C -I-
C      X(1) = XX(1)
C      X(2) = XX(2)
C      X(3) = XX(3)
      Y(1) = AM(1,1)*X(1)+AM(1,2)*X(2)+AM(1,3)*X(3)
      Y(2) = AM(2,1)*X(1)+AM(2,2)*X(2)+AM(2,3)*X(3)
      Y(3) = AM(3,1)*X(1)+AM(3,2)*X(2)+AM(3,3)*X(3)
C      YY(1) = Y(1)
C      YY(2) = Y(2)
C      YY(3) = Y(3)
      RETURN
      END

      SUBROUTINE NBD_MCOPY(X,Y)      
      REAL*8 X(9),Y(9)
C -P- NB_MCOPY - [Y] <= [X]
C                             ! 11 12 13 !
C            [Y] =[X]     X = ! 21 22 23 !
C                             ! 31 32 33 !
C -I-
      DO     I=1,9    
        Y(I) = X(I) 
      ENDDO
      RETURN        
      END   
        
      SUBROUTINE NBD_MATMLT(X,Y,Z)
      REAL*8 X(3,3),Y(3,3),Z(3,3)
C -P- NB_MATMLT - [Z] =[X] [Y]
C                               ! 11 12 13 !
C           [Z] =[X] [Y]    X = ! 21 22 23 !
C                               ! 31 32 33 !
C -I-
      DO     I=1,3
      DO     J=1,3
        Z(I,J) = 0.0
        DO     K=1,3
          Z(I,J) = Z(I,J)+X(I,K)*Y(K,J)
        ENDDO
      ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE  NBD_EUL2MATR(ALPHA1,ALPHA2,ALPHA3,ROT_TEMP)
C
C---Converts euler angles to rotation matrix
      REAL*8 ROT_TEMP(3,3),ALPHA1,ALPHA2,ALPHA3
C
C---Local variables
      REAL*8 SIN1,COS1,SIN2,COS2,SIN3,COS3

      SIN1 = DSIN(ALPHA1)
      SIN2 = DSIN(ALPHA2)
      SIN3 = DSIN(ALPHA3)

      COS1 = DCOS(ALPHA1)
      COS2 = DCOS(ALPHA2)
      COS3 = DCOS(ALPHA3)
      ROT_TEMP(1,1) =  COS1*COS2*COS3 - SIN1*SIN3
      ROT_TEMP(1,2) = -COS1*COS2*SIN3 - SIN1*COS3
      ROT_TEMP(1,3) =  COS1*SIN2
      ROT_TEMP(2,1) =  SIN1*COS2*COS3 + COS1*SIN3
      ROT_TEMP(2,2) = -SIN1*COS2*SIN3 + COS1*COS3
      ROT_TEMP(2,3) =  SIN1*SIN2
      ROT_TEMP(3,1) = -SIN2*COS3
      ROT_TEMP(3,2) =  SIN2*SIN3
      ROT_TEMP(3,3) =  COS2

      RETURN
      END


      SUBROUTINE CHECK_TREE_STR(MDOC,IFLAG_OCC,IERR)
C -----------------------------------------------
      INTEGER*4 MDOC,IERR
C ---
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
C ---
      INTEGER   NSTLIM
      PARAMETER ( NSTLIM = 1000 )
      INTEGER*4 NSTCK,ISTACK(NSTLIM),ICSTACK(NSTLIM)
      REAL*8    ASTACK(3,3,NSTLIM),XYZ_STACK(3,NSTLIM)
C --------------------------------------
      INTEGER*4 IC,I,N
      CHARACTER LINE*80
C ---------------------------------------
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      PI180 = PI/180.0
      IERR  = 0
      IFLAG_OCC = 0
C ----
      IF(N_TREE.LE.0) RETURN

      DO ITREE=1,N_TREE

      ISTART          = IATM_FIRST_TREE(ITREE)
      ID_TREE(ISTART) = ITREE

      IF(OCCUP(ISTART).LT.0.001) IFLAG_OCC = 1
      I        = ISTART
      IC       = 1
      NSTCK    = 0

  400 CONTINUE

      N = ATM_NDIST(I)

      IF(N.LE.0.AND.NSTCK.LE.0) GO TO 500

        IF(N.EQ.0) THEN

          IF(NSTCK.LE.0) THEN
            GO TO 2000
          ENDIF
 
          I     = ISTACK (NSTCK)
          IC    = ICSTACK(NSTCK)
          NSTCK = NSTCK-1
          IF(I.LE.0.OR.IC.LE.0) THEN
            GO TO 2000
          ENDIF

        ELSE IF(N.EQ.1) THEN

          INEXT = ATM_CONN(1,I)
          ID_TREE(INEXT) = ITREE
          IF(OCCUP(INEXT).LT.0.001) IFLAG_OCC = 1
          
          IC    = 1
          I     = INEXT

        ELSE IF(N.GT.1) THEN

          INEXT = ATM_CONN(IC,I)
          ID_TREE(INEXT) = ITREE
          IF(OCCUP(INEXT).LT.0.001) IFLAG_OCC = 1

          IF(IC.LT.N) THEN
            IC    = IC + 1
            NSTCK = NSTCK + 1
            IF(NSTCK.GT.NSTLIM) THEN
              WRITE(LINE,
     *        '('' ERROR: in CHECK_TREE_STR: N-stack > '',I6)')
     *        NSTLIM
              CALL MSGERR(MDOC,LINE)
              IERR=1
              GO TO 2000
            ENDIF

            ISTACK(NSTCK)  = I
            ICSTACK(NSTCK) = IC

          ENDIF
   
          I  = INEXT
          IC = 1

        ELSE

          GO TO 2000

        ENDIF
      GO TO 400
C -----------------
  500 CONTINUE


      IB = IATM_BACK(I)

      IF(IATM_FOR(IB).LT.0) THEN
        IATM_LAST_TREE(ITREE) = IB
        IATM_FOR(IB) = -I-1
      ELSE
        IATM_LAST_TREE(ITREE) = I
        IATM_FOR(I) = -1
      ENDIF

      ENDDO

      RETURN
C ------------------
 2000 CONTINUE
      LINE = ' ERROR: CHECK_TREE_STR : wrong tree structure'
      CALL MSGERR(MDOC,LINE)
      IERR = 1
      RETURN    
      END

      SUBROUTINE CHANGE_TREE(MDOC,IDT,ISTART,IFINISH,IERR)
C -----------------------------------------------
C ---
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
C ---
      CHARACTER LINE*80,TYPE*4,TYPE_T*4
C -----------------------------------------------
      IERR = 0

      IF(ISTART.EQ.IATM_LAST_TREE_C(IDT).AND.
     *   IFINISH.EQ.IATM_FIRST_TREE_C(IDT)) THEN

C       revers
C       write(*,*) '   revers:',istart,ifinish

        I            = IATM_LAST_TREE_C(IDT)
        IATM_BACK(I) = -1
        II   = 0
        TYPE = '.'
        
  100     CONTINUE

          IF(I.LE.0) GO TO 400
          J = IATM_BACK(I)
          IF(J.LE.0) GO TO 110

          IF(I.GT.0.AND.J.GT.0) THEN

            IATM_BACK(J) = I 

            TYPE_T    = ID_PSI(I)
            ID_PSI(I) = TYPE  
            TYPE      = TYPE_T

            IATM_FOR(I) = J

          ELSE
            GO TO 400
          ENDIF

          I = J
          GO TO 100

  110   CONTINUE

        IST            = IATM_LAST_TREE_C(IDT)
        IATM_BACK(IST) = -1
        IST                    = IATM_FIRST_TREE_C(IDT)
        IATM_FIRST_TREE_C(IDT) = IATM_LAST_TREE_C(IDT)
        IATM_LAST_TREE_C(IDT)  = I

        IATM_FOR(I) = -1

      ELSE 

        IF(ISTART.NE.0) THEN

c          new start       
c          write(*,*) '   new start:',istart

          I    = ISTART 
          II   = 0
          TYPE = '.'
        
  200     CONTINUE

          IF(I.LE.0) GO TO 400

          J = IATM_BACK(I)
          IF(J.LE.0) GO TO 210

          IF(I.GT.0.AND.II.GT.0) THEN
            IATM_BACK(I) = II 

            TYPE_T    = ID_PSI(I)
            ID_PSI(I) = TYPE
            TYPE      = TYPE_T

          ENDIF   

          IATM_FOR(I) = J 

          II = I 
          I  = J
          GO TO 200

  210     CONTINUE

          IF(I.GT.0.AND.II.GT.0) THEN
            IATM_BACK(I) = II 

            ID_PSI(I) = TYPE

            IATM_FOR(I) = 0 
          ENDIF   

          IATM_FIRST_TREE_C(IDT) = ISTART
          IATM_BACK(ISTART) = -1

        ENDIF

        IF(IFINISH.NE.0) THEN

c          new finish
c          write(*,*) '   new finish:',ifinish

          I            = IFINISH 
          IATM_FOR(I) = -1
        
  300     CONTINUE

          IF(I.LE.0) GO TO 400
          J = IATM_BACK(I)
          IF(J.LE.0) GO TO 400

          IF(J.GT.0.AND.I.GT.0) THEN
            IATM_FOR(J) = I
            GO TO 310 
          ENDIF

          I = J
          GO TO 300

  310     CONTINUE

          IATM_FOR(IATM_LAST_TREE_C(IDT)) = 0
          IATM_LAST_TREE_C(IDT)           = IFINISH

        ENDIF
      ENDIF

      RETURN
 400  CONTINUE
      LINE = ' ERROR: CHANGE_TREE : wrong tree structure'
      CALL MSGERR(MDOC,LINE)
      IERR = 1
      RETURN
      END

      SUBROUTINE NEW_TREE_ORIGIN(MDOC,IERR)
C -----------------------------------------------
C ---
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
C ---
      CHARACTER LINE*80,TYPE*4,TYPE_T*4
C -----------------------------------------------
      IERR = 0
C ---
      IF(N_TREE.LE.0) RETURN

      DO ITR=1,N_TREE
C --
        N = 0
        I = IATM_LAST_TREE_C(ITR)
 100    CONTINUE
          J = IATM_BACK(I)
          IF(J.LE.0) GO TO 200
          N = N + 1
          I = J
          GO TO 100 
 200    CONTINUE
C --
        IF(N.GT.10) THEN
          NBY2 = N/2
          NB   = NBY2-2
          NA   = NBY2+2

          N1     = 0
          N2     = 0
          IMIN   = 0
          NMIN   = 1000
          NN     = 0
          I = IATM_LAST_TREE_C(ITR)
 300      CONTINUE
            J = IATM_BACK(I)
            IF(J.LE.0) GO TO 400
            NN = NN + 1
            IF(OCCUP(I).GT.0.001) N2 = I
            IF(NN.GE.NB) THEN
              DO II=1,ATM_NDIST(I)
                JJ   = ATM_CONN(II,I)
                IF(ATM_NDIST(JJ).EQ.0.AND.OCCUP(I).GT.0.001) THEN
                  N1 = I 
                ENDIF
              ENDDO
              IF(ATM_NDIST(I).LT.NMIN.AND.OCCUP(I).GT.0.001) THEN
                IMIN = I
                NMIN = ATM_NDIST(I)  
              ENDIF
            ENDIF
            IF(NN.GE.NA) GO TO 400
            I = J
            GO TO 300 
 400      CONTINUE
          ISTART = 0
          IF(N1.GT.0) THEN
            ISTART = N1
          ELSE IF(NMIN.GT.0) THEN
            ISTART = NMIN
          ELSE IF(N2.GT.0) THEN
            ISTART = N2
          ENDIF
          IF(ISTART.GT.0) THEN
            IFINISH = 0
            CALL CHANGE_TREE(MDOC,ITR,ISTART,IFINISH,IERR)
            IF(IERR.NE.0) RETURN
            IS = IATM_FIRST_TREE_C(ITR) 
            XYZ_TREE(1,ITR) = XYZ_CRD(1,IS)
            XYZ_TREE(2,ITR) = XYZ_CRD(2,IS)
            XYZ_TREE(3,ITR) = XYZ_CRD(3,IS)
          ENDIF
        ENDIF
      ENDDO

      DO ITR=1,N_TREE 
        CALL SET_CONNECTIVITIES(ITR,IERR)
      ENDDO
C ---
      RETURN
      END

      SUBROUTINE ALTERNATIVE_TREE_CORRECTION(IMODE,IFLAG_ALT,IERR)      
C --------------------------------------------------------
C      
C --------------------------------------------------------
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
      CHARACTER LINE*80,TYPE*4,TYPE_T*4,TYPE_TT*4,TYPE_TTT*4
C -----------------------------------
      IERR      = 0
      IFLAG_ALT = 0
      IF(N_ATOM.LE.1) RETURN
      DO I=1,N_ATOM-1
        IFOR = IATM_FOR(I)
        DO J=I+1,N_ATOM
          JFOR = IATM_FOR(J)
C         alternative branch ?
          IF(IFOR.GT.0.AND.IFOR.EQ.JFOR) THEN  
C           start atoms are different ?                        
            IFLAG_ALT = 1
            NI = 0
            II = I
 100        CONTINUE
            III = IATM_BACK(II)
            IF(III.LE.0) GO TO 200
            NI = NI + 1
            II = III
            GO TO 100 
 200        CONTINUE
            ISTART = II
C -         
            JJ = J  
            NJ = 0
 300        CONTINUE
            JJJ = IATM_BACK(JJ)
            IF(JJJ.LE.0) GO TO 400
            NJ = NJ + 1
            JJ = JJJ
            GO TO 300 
 400        CONTINUE
            JSTART = JJ
C -
            IF(ISTART.EQ.JSTART) THEN
C             add extra bond 
              IATM_FOR(J) = 0                                
              IF(IATM_EXTR(J).LE.0)THEN
                IATM_EXTR(J) = I
              ELSE IF(IATM_EXTR2(I).LE.0) THEN
                IATM_EXTR2(J) = I 
              ENDIF 
            ELSE
C             change direction of J-branch          
              II   = J
              III  = JFOR
              IIII = 0
              IF(IMODE.EQ.0) THEN
                TYPE_T  = ID_PSI(JFOR)               
                TYPE_TT = ID_PSI(J)               
                TYPE = '.'
              ELSE
                TYPE      = ID_PSI(J)               
                ID_PSI(J) = ID_PSI(JFOR)               
              ENDIF
  500         CONTINUE

              IJ = IATM_BACK(II)
              IF(IJ.LE.0) GO TO 510

              IF(II.GT.0.AND.III.GT.0) THEN
                IATM_BACK(II) = III
              ENDIF

              IF(IMODE.NE.0) THEN
                IF(IJ.GT.0.AND.IIII.GT.0) THEN
                  TYPE_TTT   = ID_PSI(IJ)
                  ID_PSI(IJ) = TYPE
                  TYPE       = TYPE_T
                  TYPE_T     = TYPE_TT
                  TYPE_TT    = TYPE_TTT
                ENDIF
              ELSE
                IF(IJ.GT.0.AND.II.GT.0) THEN
                  TYPE_T     = ID_PSI(IJ)
                  ID_PSI(IJ) = TYPE
                  TYPE       = TYPE_T        
                ENDIF
              ENDIF

              IATM_FOR(II) = IJ 
              IIII = III
              III  = II 
              II   = IJ
              GO TO 500

  510         CONTINUE

              IF(II.GT.0.AND.III.GT.0) THEN
                IATM_BACK(II) = III 

                ID_PSI(II)    = TYPE

                IATM_FOR(II)  = 0 
              ENDIF   

              IATM_BACK(J) = IFOR 

            ENDIF

          ENDIF
        ENDDO
      ENDDO
C ---      
      RETURN
      END 

      SUBROUTINE PARTIAL_TREE_INITIALIZATION(MDOC,IERR)
C --------------------------------------------------------
C    
C --------------------------------------------------------
      INTEGER MDOC,IERR
C ---
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
C ---
      CHARACTER LINE*80
C ----------------------------------
C     IERR
C      10    N_TREE = 0 
C      11    IATM_FIRST_TREE() or IATM_LAST_TREE() = 0
C      12    IATM_FIRST_TREE(),IATM_LAST_TREE() not in the same tree
C      13    new FIRST or LAST not backbone atom
C      14    new FIRST or LAST has alt. atoms
C      15    some trees overlap
C -----------------------------------
      IERR = 0
      IF(N_TREE.LE.0) THEN
        IERR = 10
        RETURN
      ENDIF      
C ---
      DO ITR=1,N_TREE

        IST = IATM_FIRST_TREE(ITR)
        IFN = IATM_LAST_TREE (ITR)
        IF(IST.LE.0.OR.IFN.LE.0) THEN
          IERR = 11
          RETURN
        ENDIF
C ---
C       the same tree ?
        IDT = ID_TREE(IST)
        IF(IDT.NE.ID_TREE(IFN)) THEN
          IERR = 12
          RETURN
        ENDIF
C ---
C       get first and last atoms in residues
        I    = IST
        IRES = I_RESID(I)  
 100    CONTINUE
          IB = IATM_BACK(I)
          IR = 0
          IF(IB.GT.0) IR = I_RESID(IB)   
          IF(IR.NE.IRES) GO TO 110
          I = IB 
          GO TO 100
 110    CONTINUE
        IST = I
C ---
        I    = IFN
        IRES = I_RESID(I)  
 200    CONTINUE
          IFR = IATM_FOR(I)
          IR = 0
          IF(IFR.GT.0) IR = I_RESID(IFR)   
          IF(IR.NE.IRES) GO TO 210
          I = IFR 
          GO TO 200
 210    CONTINUE
        IFN = I
C ---         
C       IFN backbone ?
        I    = IST             
        IRES = I_RESID(I)  
 300    CONTINUE
          IFR = IATM_FOR(I)
          IF(IFR.EQ.IFN) GO TO 310 
          IR = 0
          IF(IFR.GT.0) IR = I_RESID(IFR)   
          IF(IR.NE.IRES) THEN
            IERR = 13
            RETURN
          ENDIF
          I = IFR 
          GO TO 300
 310    CONTINUE
C ---
C       alt ?        
        IF(ID_ALT(IST).NE.'.'.OR.ID_ALT(IFN).NE.'.') THEN 
          IERR = 14
          RETURN
        ENDIF
C ---
C       overlap 
        IF(ITR.GT.1) THEN
          DO JTR=1,ITR-1
            JST = IATM_FIRST_TREE(JTR)
            JFN = IATM_LAST_TREE (JTR)
            I = IFN
            IF(I.EQ.JST.OR.I.EQ.JFN) THEN
              WRITE(*,*)'Here I eq.JST ',I,JST,JFN
              IERR = 15
              RETURN
            ENDIF 
 400        CONTINUE
              IF(I.EQ.JST.OR.I.EQ.JFN) THEN
              WRITE(*,*)'Here I eq.JST iJ ',I,JST,JFN

                IERR = 15
                RETURN
              ENDIF 
              IB = IATM_BACK(I)
              I = IB
              IF(IB.LE.0.OR.IB.EQ.IST) GO TO 410
            GO TO 400  
 410        CONTINUE
            IF(I.EQ.JST.OR.I.EQ.JFN) THEN
              WRITE(*,*)'Here I eq.JST ',I,JST,JFN
              IERR = 15
              RETURN
            ENDIF 
          ENDDO
        ENDIF
C ---   
C     store info
        IBACK_S_INIT   (ITR) = IATM_BACK(IST)
        IATM_BACK(IST)       =-1
        ID_TREE_INIT   (ITR) = ABS(ID_TREE(IST))
        IFOR_F_INIT    (ITR) = IATM_FOR(IFN)
        IATM_FIRST_TREE(ITR) = IST
        IATM_LAST_TREE (ITR) = IFN
C
        IFOR  = IATM_FOR(IFN)
        NDIST = ATM_NDIST(IFN)
        IF(IFOR.GT.0) THEN   
          ATM_CONN(NDIST,IFN) = 0
          NDIST = NDIST - 1
        ENDIF
        ATM_NDIST(IFN) = NDIST 
        IF(NDIST.GT.0) THEN         
          IATM_FOR(IFN) = -ATM_CONN(NDIST,IFN)-1
        ELSE 
          IATM_FOR(IFN) = -1
        ENDIF 
      ENDDO
C ---      
      RETURN
      END 

      SUBROUTINE BACK_TO_INITIAL_TREE(MDOC,IERR)
C --------------------------------------------------------
C    
C --------------------------------------------------------
      INTEGER MDOC,IERR
C ---
      INCLUDE 'atom_com.fh'
      INCLUDE 'atom_com_str.fh'
      INCLUDE 'ref_com_str.fh'
C ---
      CHARACTER LINE*80
C -----------------------------------
      IERR = 0
C ---
      DO ITR=1,N_TREE
        IST  = IATM_FIRST_TREE(ITR)
        IFN  = IATM_LAST_TREE (ITR)
        CALL CHANGE_TREE(MDOC,ITR,IST,IFN,IERR)
        IF(IERR.NE.0) THEN
          RETURN
        ENDIF
        IATM_BACK(IST) = IBACK_S_INIT(ITR)
        IATM_FOR (IFN) = IFOR_F_INIT (ITR)
        NDIST = ATM_NDIST(IFN)
        IFOR  = IATM_FOR(IFN)
        IF(IFOR.GT.0) THEN   
          NDIST = NDIST + 1
          ATM_CONN(NDIST,IFN) = IFOR
        ENDIF
        ATM_NDIST(IFN) = NDIST 
        IMODE = 2
        CALL TREE_INITIALIZATION(MDOC,IMODE,IFLAG_OCC,IERR)
        IF(IERR.NE.0) THEN
          RETURN
        ENDIF
      ENDDO
C ---      
      RETURN
      END 
