      SUBROUTINE  IHEAP_SORT_R(N,NKEYS,A_KEY,INDEX_R)
      IMPLICIT NONE
C
C----Sorting using heapsort. 
C----A        contains keys
C----INDEX_R  index of records to be sorted
C----N        number of records
C----NKEYS    number of keys
C
C---Sorting orders should also be added. At the moment this function is very 
c---primitive
C---Reference
C
c---Knuth, The art of computer programming Volume 3
C---1998
C
      INTEGER    N,NKEYS
      integer    INDEX_R(*)
      integer    A_KEY(*)
C
      integer    T_KEY(10),T1_KEY(10)
C
      integer   INDEX_C
      INTEGER   L,M,I_TEMP,L1,MKEY1_ADD,MKEY2_ADD,I_KEY,N1
C
C--------------------------------------------------------------
      L1 = N/2
C
C---Create heap. everybody tends to reach his level of incomptence
cd      WRITE(*,*)'In heap_sort'

      DO   L=L1,1,-1
        CALL SIFT_UP(N,L,NKEYS,A_KEY,INDEX_R)
      ENDDO
C
c--Remove heaps  one after another
      N1 = N-1
      DO   M=N1,1,-1
        INDEX_C = INDEX_R(1)
        INDEX_R(1) = INDEX_R(M+1)
        INDEX_R(M+1) = INDEX_C
        MKEY1_ADD = M*NKEYS
        DO   I_KEY=1,NKEYS
          MKEY2_ADD = MKEY1_ADD + I_KEY
          T_KEY(I_KEY) = A_KEY(I_KEY)
          A_KEY(I_KEY) = A_KEY(MKEY2_ADD)
          A_KEY(MKEY2_ADD) = T_KEY(I_KEY)
        ENDDO

        CALL SIFT_UP(M,1,NKEYS,A_KEY,INDEX_R)
      ENDDO
      END
C

      SUBROUTINE SIFT_UP(M,L,NKEYS,A_KEY,INDEX_R)
c
c---Sift ip process in heap sort. This implementation is 
C---intended to work for multykey cases. I am not sure this treatment is best
C---for multy key cases. Other idea will have to be tested.
      IMPLICIT NONE
      INTEGER M,L,NKEYS
      integer INDEX_R(*)
      integer A_KEY(*)
C
      INTEGER I,J,IKEY_ADD,NKEYS1,JKEY_ADD,JKEY1_ADD,LKEY_ADD,
     &        I_KEY,J_KEY,I1_KEY
      integer KEY_T(10),INDEX_C
C
C---Intitialise sift up (in Knuth's terminology H2)
      INDEX_C = INDEX_R(L)
      NKEYS1  = -NKEYS
      LKEY_ADD = L*NKEYS+NKEYS1
      DO  I_KEY=1,NKEYS
        KEY_T(I_KEY) = A_KEY(LKEY_ADD + I_KEY)
      ENDDO
c
C---H3
      J = L
 40   CONTINUE
C
c---Start sift up. Compare I with 2*I or 2*I+1
C---H4
      I = J
      J = J + J
C
C---If(J.GT.M) then return time
      IKEY_ADD = I*NKEYS + NKEYS1
      JKEY_ADD = J*NKEYS + NKEYS1
      IF(J.LE.M) THEN
         IF(J.LT.M) THEN
C
c---J.lt.M find maximum of J and J + 1 (which is 2*I, 2*I+1)
           JKEY1_ADD = JKEY_ADD + NKEYS
C
C---H5 
           DO   I_KEY=1,NKEYS
             IF(A_KEY(JKEY_ADD+I_KEY).LT.A_KEY(JKEY1_ADD+I_KEY)) THEN
C
c---Next record is smaller, Take it
               J = J + 1
               JKEY_ADD = JKEY1_ADD
               GOTO 55
             ELSE IF(A_KEY(JKEY_ADD+I_KEY).GT.
     &                                A_KEY(JKEY1_ADD+I_KEY))THEN
C
c--Next record is greater. No need to proceed
               GOTO 55
             ENDIF
C
c----Cannot decide yet. Check another key
           ENDDO
         ENDIF
 55      CONTINUE
         DO   I_KEY = 1,NKEYS
C
C---compare saved record in initialisation with record J. If
C---saved is smaller than current then then put for i (2*I or 2*I+1)
           IF(KEY_T(I_KEY).LT.A_KEY(JKEY_ADD + I_KEY)) THEN
C
C---H6 above H7 below
             INDEX_R(I) = INDEX_R(J)
             DO   I1_KEY=1,NKEYS
               A_KEY(IKEY_ADD+I1_KEY) = A_KEY(JKEY_ADD+I1_KEY)
             ENDDO
             GOTO 40
           ELSE IF(KEY_T(I_KEY).GT.A_KEY(JKEY_ADD + I_KEY)) THEN
             GOTO 80
           ENDIF
         ENDDO
       ENDIF
 80    CONTINUE
C
c---Put saved record to i-th and exit from sift up
C---H8
       INDEX_R(I) = INDEX_C
       DO   I_KEY=1,NKEYS
         A_KEY(IKEY_ADD+I_KEY) = KEY_T(I_KEY)
       ENDDO
       RETURN
       END
c
      SUBROUTINE  IHEAP_SORT_0(N,NKEYS,A_KEY)
      IMPLICIT NONE
C
C----Sorting using heapsort. This routine sorts keys only 
C----A        contains keys
C----N        number of records
C----NKEYS    number of keys
C
C---Sorting orders should also be added. At the moment this function is very 
c---primitive
C---Reference
C
c---Knuth, The art of computer programming Volume 3
C---1998
C
      INTEGER    N,NKEYS
      integer       A_KEY(*)
C
      integer    T_KEY(10),T1_KEY(10)
C
      INTEGER   L,M,I_TEMP,L1,MKEY1_ADD,MKEY2_ADD,I_KEY,N1
C
C--------------------------------------------------------------
      L1 = N/2
C
C---Create heap. everybody tends to reach his level of incomptence
cd      WRITE(*,*)'In heap_sort'

      DO   L=L1,1,-1
        CALL SIFT_UP_0(N,L,NKEYS,A_KEY)
      ENDDO
C
c--Remove heaps  one after another
      N1 = N-1
      DO   M=N1,1,-1
        MKEY1_ADD = M*NKEYS
        DO   I_KEY=1,NKEYS
          MKEY2_ADD = MKEY1_ADD + I_KEY
          T_KEY(I_KEY) = A_KEY(I_KEY)
          A_KEY(I_KEY) = A_KEY(MKEY2_ADD)
          A_KEY(MKEY2_ADD) = T_KEY(I_KEY)
        ENDDO

        CALL SIFT_UP_0(M,1,NKEYS,A_KEY)
      ENDDO
      END
C

      SUBROUTINE SIFT_UP_0(M,L,NKEYS,A_KEY)
c
c---Sift ip process in heap sort. This implementation is 
C---intended to work for multykey cases. I am not sure this treatment is best
C---for multy key cases. Other idea will have to be tested.
      IMPLICIT NONE
      INTEGER M,L,NKEYS
      integer A_KEY(*)
C
      INTEGER I,J,IKEY_ADD,NKEYS1,JKEY_ADD,JKEY1_ADD,LKEY_ADD,
     &        I_KEY,J_KEY,I1_KEY
      integer KEY_T(10)
C
C---Intitialise sift up (in Knuth's terminology H2)
      NKEYS1  = -NKEYS
      LKEY_ADD = L*NKEYS+NKEYS1
      DO  I_KEY=1,NKEYS
        KEY_T(I_KEY) = A_KEY(LKEY_ADD + I_KEY)
      ENDDO
c
C---H3
      J = L
 40   CONTINUE
C
c---Start sift up. Compare I with 2*I or 2*I+1
C---H4
      I = J
      J = J + J
C
C---If(J.GT.M) then return time
      IKEY_ADD = I*NKEYS + NKEYS1
      JKEY_ADD = J*NKEYS + NKEYS1
      IF(J.LE.M) THEN
         IF(J.LT.M) THEN
C
c---J.lt.M find maximum of J and J + 1 (which is 2*I, 2*I+1)
           JKEY1_ADD = JKEY_ADD + NKEYS
C
C---H5 
           DO   I_KEY=1,NKEYS
             IF(A_KEY(JKEY_ADD+I_KEY).LT.A_KEY(JKEY1_ADD+I_KEY)) THEN
C
c---Next record is smaller, Take it
               J = J + 1
               JKEY_ADD = JKEY1_ADD
               GOTO 55
             ELSE IF(A_KEY(JKEY_ADD+I_KEY).GT.
     &                                A_KEY(JKEY1_ADD+I_KEY))THEN
C
c--Next record is greater. No need to proceed
               GOTO 55
             ENDIF
C
c----Cannot decide yet. Check another key
           ENDDO
         ENDIF
 55      CONTINUE
         DO   I_KEY = 1,NKEYS
C
C---compare saved record in initialisation with record J. If
C---saved is smaller than current then then put for i (2*I or 2*I+1)
           IF(KEY_T(I_KEY).LT.A_KEY(JKEY_ADD + I_KEY)) THEN
C
C---H6 above H7 below
             DO   I1_KEY=1,NKEYS
               A_KEY(IKEY_ADD+I1_KEY) = A_KEY(JKEY_ADD+I1_KEY)
             ENDDO
             GOTO 40
           ELSE IF(KEY_T(I_KEY).GT.A_KEY(JKEY_ADD + I_KEY)) THEN
             GOTO 80
           ENDIF
         ENDDO
       ENDIF
 80    CONTINUE
C
c---Put saved record to i-th and exit from sift up
C---H8
       DO   I_KEY=1,NKEYS
         A_KEY(IKEY_ADD+I_KEY) = KEY_T(I_KEY)
       ENDDO
       RETURN
       END
c
c---  Sorting character string arrays

      SUBROUTINE  CHEAP_SORT_R(N,NKEYS,A_KEY,INDEX_R)
      IMPLICIT NONE
C
C----Sorting using heapsort. 
C----A        contains keys
C----INDEX_R  index of records to be sorted
C----N        number of records
C----NKEYS    number of keys
C
C---Sorting orders should also be added. At the moment this function is very 
c---primitive
C---Reference
C
c---Knuth, The art of computer programming Volume 3
C---1998
C
      INTEGER    N,NKEYS
      integer    INDEX_R(*)
      character(len=*) ::   A_KEY(N*NKEYS)
C
      character(len=10) ::   T_KEY(10),T1_KEY(10)
C
      integer   INDEX_C
      INTEGER   L,M,I_TEMP,L1,MKEY1_ADD,MKEY2_ADD,I_KEY,N1
C
C--------------------------------------------------------------
      L1 = N/2
C
C---Create heap. everybody tends to reach his level of incomptence
cd      WRITE(*,*)'In heap_sort'

      DO   L=L1,1,-1
        CALL cSIFT_UP(N,N,L,NKEYS,A_KEY,INDEX_R)
      ENDDO
C
c--Remove heaps  one after another
      N1 = N-1
      DO   M=N1,1,-1
        INDEX_C = INDEX_R(1)
        INDEX_R(1) = INDEX_R(M+1)
        INDEX_R(M+1) = INDEX_C
        MKEY1_ADD = M*NKEYS
        DO   I_KEY=1,NKEYS
          MKEY2_ADD = MKEY1_ADD + I_KEY
          T_KEY(I_KEY) = A_KEY(I_KEY)
          A_KEY(I_KEY) = A_KEY(MKEY2_ADD)
          A_KEY(MKEY2_ADD) = T_KEY(I_KEY)
        ENDDO
        CALL cSIFT_UP(M,N,1,NKEYS,A_KEY,INDEX_R)
      ENDDO
      END
C

      SUBROUTINE cSIFT_UP(M,N,L,NKEYS,A_KEY,INDEX_R)
c
c---Sift ip process in heap sort. This implementation is 
C---intended to work for multykey cases. I am not sure this treatment is best
C---for multy key cases. Other idea will have to be tested.
      IMPLICIT NONE
      INTEGER M,N,L,NKEYS
      integer INDEX_R(*)
      character(len=*) :: A_KEY(N*NKEYS)
C
      INTEGER I,J,IKEY_ADD,NKEYS1,JKEY_ADD,JKEY1_ADD,LKEY_ADD,
     &        I_KEY,J_KEY,I1_KEY
      character(len=10) :: KEY_T(10)
      integer INDEX_C
C
C---Intitialise sift up (in Knuth's terminology H2)

      INDEX_C = INDEX_R(L)
      NKEYS1  = -NKEYS
      LKEY_ADD = L*NKEYS+NKEYS1
      DO  I_KEY=1,NKEYS
        KEY_T(I_KEY) = A_KEY(LKEY_ADD + I_KEY)
      ENDDO
c
C---H3
      J = L
 40   CONTINUE
C
c---Start sift up. Compare I with 2*I or 2*I+1
C---H4
      I = J
      J = J + J
C
C---If(J.GT.M) then return time
      IKEY_ADD = I*NKEYS + NKEYS1
      JKEY_ADD = J*NKEYS + NKEYS1
      IF(J.LE.M) THEN
         IF(J.LT.M) THEN
C
c---J.lt.M find maximum of J and J + 1 (which is 2*I, 2*I+1)
           JKEY1_ADD = JKEY_ADD + NKEYS
C
C---H5 
           DO   I_KEY=1,NKEYS
             IF(A_KEY(JKEY_ADD+I_KEY).LT.A_KEY(JKEY1_ADD+I_KEY)) THEN
C
c---Next record is smaller, Take it
               J = J + 1
               JKEY_ADD = JKEY1_ADD
               GOTO 55
             ELSE IF(A_KEY(JKEY_ADD+I_KEY).GT.
     &                                A_KEY(JKEY1_ADD+I_KEY))THEN
C
c--Next record is greater. No need to proceed
               GOTO 55
             ENDIF
C
c----Cannot decide yet. Check another key
           ENDDO
         ENDIF
 55      CONTINUE
         DO   I_KEY = 1,NKEYS
C
C---compare saved record in initialisation with record J. If
C---saved is smaller than current then then put for i (2*I or 2*I+1)
           IF(KEY_T(I_KEY).LT.A_KEY(JKEY_ADD + I_KEY)) THEN
C
C---H6 above H7 below
             INDEX_R(I) = INDEX_R(J)
             DO   I1_KEY=1,NKEYS
               A_KEY(IKEY_ADD+I1_KEY) = A_KEY(JKEY_ADD+I1_KEY)
             ENDDO
             GOTO 40
           ELSE IF(KEY_T(I_KEY).GT.A_KEY(JKEY_ADD + I_KEY)) THEN
             GOTO 80
           ENDIF
         ENDDO
       ENDIF
 80    CONTINUE
C
c---Put saved record to i-th and exit from sift up
C---H8
       INDEX_R(I) = INDEX_C
       DO   I_KEY=1,NKEYS
         A_KEY(IKEY_ADD+I_KEY) = KEY_T(I_KEY)
       ENDDO
       RETURN
       END
