      SUBROUTINE AMOD_R(A,B,IAMOD,AREMAIN)
      IMPLICIT NONE
C
C---This subroutine calculates mod(a,|b|) and int(a/|b|)
C
C----|B| = 0 must be satisfied
C
C---Real scalar parameters
      REAL A,B,AREMAIN,B1
C
C---Intrinsic functions
      INTEGER INT
      INTRINSIC INT
      REAL ABS
      INTRINSIC ABS
      REAL FLOAT
      INTRINSIC FLOAT
C
C---Integer scalar parameters
      INTEGER IAMOD
C
      IF(B.EQ.1.0) THEN
        IAMOD = INT(ABS(A))
        IF(A.LT.0.0) IAMOD = -IAMOD - 1
        AREMAIN = A - FLOAT(IAMOD)
        RETURN
      ENDIF
C
      B1 = ABS(B)
      IF(B1.GT.0.0) THEN
        IAMOD = INT(ABS(A)/B1)
        IF(A.LT.0.0) IAMOD = -IAMOD-1
        AREMAIN = A - FLOAT(IAMOD)*B1
      ELSE
        IAMOD = 0
        AREMAIN = -A
      ENDIF
      RETURN
      END
c
      subroutine swap_int(a,b)
      implicit none
      integer a,b
c
      integer i
c
      i=a
      a=b
      b=i

      return
      end
c
      subroutine swap_real(a,b)
      implicit none
      real a,b
c
      real t
c
      t=a
      a=b
      b=t

      return
      end
c
      SUBROUTINE POLAR(TRMAT,OMEGA,PHI,CHI)
C     ========================
C
C---- This s/r works out various rotation angles corresponding
C     to a given rotation matrix.
C     It could easily be extended to give other sets.
C
      INCLUDE 'const.fh'
C     .. Array Arguments ..
      REAL TRMAT(3,3)
C     ..
C     .. Local Scalars ..
      REAL CHI,CHK,COSCHI,OMEGA,PHI,R13,R23,R31,R32,SINCHI,SOMEGA,
     +     THETA1,THETA2,THETA3,TRACE
C     ..
C     .. Local Arrays ..
      REAL DC(5)
C     ..
      CHI = 0.0
      OMEGA = 0.0
      PHI = 0.0

      TRACE = TRMAT(1,1) + TRMAT(2,2) + TRMAT(3,3)
      IF (TRACE.LT.3.0) THEN
        IF (TRMAT(3,3).LT.0.99999) THEN
          IF (TRMAT(3,3).GT.-0.999999) THEN
            THETA2 = ACOS(AMAX1(-1.0,AMIN1(1.0,TRMAT(3,3))))*RTODEG
C
            R13 = TRMAT(1,3)
            R23 = TRMAT(2,3)
            R31 = TRMAT(3,1)
            R32 = TRMAT(3,2)
            IF (R23.LT.0.0) THEN
              R13 = -R13
              R23 = -R23
              R31 = -R31
              R32 = -R32
              THETA2 = -THETA2
            END IF
            THETA3 = 0.0
            THETA1 = 0.0
            IF(R32**2+R31**2.NE.0.0) 
     +          THETA3 = ATAN2(R32,-R31)*RTODEG
            IF(R23**2+R13**2.NE.0.0)
     +           THETA1 = ATAN2(R23,R13)*RTODEG
C
C---- Spherical polars ref patterson int tab vol2 p59
            DC(1) = 0.0
            DC(2) = 0.0
            DC(3) = 0.0
            COSCHI = TRACE/2.0 - 0.5
            SINCHI = SQRT(ABS(1.0-COSCHI*COSCHI))
            CHI = 0.0
            IF(SINCHI**2+COSCHI**2.NE.0.0)
     +            CHI = ATAN2(SINCHI,COSCHI)*RTODEG
            CHK = ABS(CHI)
            IF (CHK.GT.179.5) THEN
              GO TO 10
            ELSE
              DC(1) = (TRMAT(3,2)-TRMAT(2,3))/ (2.0*SINCHI)
              DC(2) = (TRMAT(1,3)-TRMAT(3,1))/ (2.0*SINCHI)
              DC(3) = (TRMAT(2,1)-TRMAT(1,2))/ (2.0*SINCHI)
              CHK = DC(1)**2 + DC(2)**2 + DC(3)**2
              IF (CHK.GT.0.8) THEN
                GO TO 20
              ELSE
                GO TO 10
              END IF
            END IF
          END IF
        END IF
C
C---- U_ANISO =0 or 180  can only find alpha + or - gamma.
        THETA2 = 0.0
        IF (TRMAT(3,3).LT.0.0) THETA2 = 180.0
        THETA3 = 0.0
        IF(TRMAT(2,1)**2+TRMAT(2,2)**2.NE.0.0) 
     +       THETA3 = ATAN2(TRMAT(2,1),TRMAT(2,2))*RTODEG
        THETA1 = 0.0
        IF (THETA2.EQ.0) CHI = THETA3
        IF (THETA2.EQ.180.0) CHI = 180.0
C
C---- IF CHI =180  COSCHI=-1,SINCHI=0
   10   DC(1) = SQRT(ABS(TRMAT(1,1)*0.5+0.5))
        DC(2) = SQRT(ABS(TRMAT(2,2)*0.5+0.5))
        DC(3) = SQRT(ABS(TRMAT(3,3)*0.5+0.5))
C
C---- Assume dc(1) positive
        IF (DC(1).NE.0.0) THEN
          IF (DC(2).NE.0.0) DC(2) = DC(2)*SIGN(1.0,TRMAT(1,2))
          IF (DC(3).NE.0.0) DC(3) = DC(3)*SIGN(1.0,TRMAT(1,3))
        ELSE IF (DC(2).NE.0.0) THEN
          IF (DC(3).NE.0.0) DC(3) = SIGN(1.0,TRMAT(2,3))*DC(3)
        END IF
   20   DC(4) = DC(1)
        DC(5) = DC(2)
C
        SOMEGA = SQRT(ABS(1.0-DC(3)*DC(3)))
        OMEGA = 0.0
        IF(SOMEGA**2+DC(3)**2.NE.0.0)
     +      OMEGA = ATAN2(SOMEGA,DC(3))*RTODEG
        CHK = DC(2)*DC(2) + DC(1)*DC(1)
        PHI = 999
        IF (CHK.GT.0.0) PHI = RTODEG*ATAN2(DC(2),DC(1))
      END IF
      END
